Liferay.Loader.define("frontend-js-metal-web@1.0.24/metal-jsx/src/JSXComponent", ['exports', 'metal/src/metal', 'metal-component/src/all/component', 'metal-incremental-dom/src/all/incremental-dom', './JSXDataManager', './JSXRenderer', './iDOMHelpers'], function (exports, _metal, _component, _incrementalDom, _JSXDataManager, _JSXRenderer) {
	'use strict';

	Object.defineProperty(exports, "__esModule", {
		value: true
	});

	var _component2 = _interopRequireDefault(_component);

	var _incrementalDom2 = _interopRequireDefault(_incrementalDom);

	var _JSXDataManager2 = _interopRequireDefault(_JSXDataManager);

	var _JSXRenderer2 = _interopRequireDefault(_JSXRenderer);

	function _interopRequireDefault(obj) {
		return obj && obj.__esModule ? obj : {
			default: obj
		};
	}

	function _toConsumableArray(arr) {
		if (Array.isArray(arr)) {
			for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
				arr2[i] = arr[i];
			}

			return arr2;
		} else {
			return Array.from(arr);
		}
	}

	function _classCallCheck(instance, Constructor) {
		if (!(instance instanceof Constructor)) {
			throw new TypeError("Cannot call a class as a function");
		}
	}

	var _createClass = function () {
		function defineProperties(target, props) {
			for (var i = 0; i < props.length; i++) {
				var descriptor = props[i];
				descriptor.enumerable = descriptor.enumerable || false;
				descriptor.configurable = true;
				if ("value" in descriptor) descriptor.writable = true;
				Object.defineProperty(target, descriptor.key, descriptor);
			}
		}

		return function (Constructor, protoProps, staticProps) {
			if (protoProps) defineProperties(Constructor.prototype, protoProps);
			if (staticProps) defineProperties(Constructor, staticProps);
			return Constructor;
		};
	}();

	function _possibleConstructorReturn(self, call) {
		if (!self) {
			throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
		}

		return call && (typeof call === "object" || typeof call === "function") ? call : self;
	}

	function _inherits(subClass, superClass) {
		if (typeof superClass !== "function" && superClass !== null) {
			throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
		}

		subClass.prototype = Object.create(superClass && superClass.prototype, {
			constructor: {
				value: subClass,
				enumerable: false,
				writable: true,
				configurable: true
			}
		});
		if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
	}

	var JSXComponent = function (_Component) {
		_inherits(JSXComponent, _Component);

		function JSXComponent() {
			_classCallCheck(this, JSXComponent);

			return _possibleConstructorReturn(this, (JSXComponent.__proto__ || Object.getPrototypeOf(JSXComponent)).apply(this, arguments));
		}

		_createClass(JSXComponent, [{
			key: 'handleStateWillChange_',
			value: function handleStateWillChange_(event) {
				if (event.type !== 'state') {
					this.willReceiveProps(event.changes);
				}
			}
		}, {
			key: 'otherProps',
			value: function otherProps() {
				var removeKeys = [].concat(_toConsumableArray(this.getDataManager().getPropsInstance(this).getStateKeys()), ['key', 'ref']);

				var retObj = _metal.object.mixin({}, this.props);

				for (var i = 0; i < removeKeys.length; i++) {
					var key = removeKeys[i];

					if (retObj.hasOwnProperty(key)) {
						delete retObj[key];
					}
				}

				return retObj;
			}
		}, {
			key: 'willReceiveProps',
			value: function willReceiveProps() {}
		}], [{
			key: 'render',
			value: function render() {
				return _incrementalDom2.default.render.apply(_incrementalDom2.default, arguments);
			}
		}]);

		return JSXComponent;
	}(_component2.default);

	JSXComponent.DATA_MANAGER = _JSXDataManager2.default;
	JSXComponent.RENDERER = _JSXRenderer2.default;

	exports.default = JSXComponent;
});
//# sourceMappingURL=JSXComponent.js.map
