Liferay.Loader.define("frontend-js-metal-web@1.0.24/metal-jsx/src/JSXDataManager", ['exports', 'metal/src/metal', 'metal-component/src/all/component', 'metal-state/src/all/state'], function (exports, _metal, _component, _state) {
	'use strict';

	Object.defineProperty(exports, "__esModule", {
		value: true
	});

	var _state2 = _interopRequireDefault(_state);

	function _interopRequireDefault(obj) {
		return obj && obj.__esModule ? obj : {
			default: obj
		};
	}

	function _classCallCheck(instance, Constructor) {
		if (!(instance instanceof Constructor)) {
			throw new TypeError("Cannot call a class as a function");
		}
	}

	var _createClass = function () {
		function defineProperties(target, props) {
			for (var i = 0; i < props.length; i++) {
				var descriptor = props[i];
				descriptor.enumerable = descriptor.enumerable || false;
				descriptor.configurable = true;
				if ("value" in descriptor) descriptor.writable = true;
				Object.defineProperty(target, descriptor.key, descriptor);
			}
		}

		return function (Constructor, protoProps, staticProps) {
			if (protoProps) defineProperties(Constructor.prototype, protoProps);
			if (staticProps) defineProperties(Constructor, staticProps);
			return Constructor;
		};
	}();

	function _possibleConstructorReturn(self, call) {
		if (!self) {
			throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
		}

		return call && (typeof call === "object" || typeof call === "function") ? call : self;
	}

	function _inherits(subClass, superClass) {
		if (typeof superClass !== "function" && superClass !== null) {
			throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
		}

		subClass.prototype = Object.create(superClass && superClass.prototype, {
			constructor: {
				value: subClass,
				enumerable: false,
				writable: true,
				configurable: true
			}
		});
		if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
	}

	var JSXDataManager = function (_ComponentDataManager) {
		_inherits(JSXDataManager, _ComponentDataManager);

		function JSXDataManager() {
			_classCallCheck(this, JSXDataManager);

			return _possibleConstructorReturn(this, (JSXDataManager.__proto__ || Object.getPrototypeOf(JSXDataManager)).apply(this, arguments));
		}

		_createClass(JSXDataManager, [{
			key: 'addUnconfiguredProps_',
			value: function addUnconfiguredProps_(component, props, data) {
				var keys = Object.keys(data);
				for (var i = 0; i < keys.length; i++) {
					if (!props.hasStateKey(keys[i])) {
						component.props[keys[i]] = data[keys[i]];
					}
				}
			}
		}, {
			key: 'createState_',
			value: function createState_(comp, config) {
				var ctor = comp.constructor;
				comp.props = {};
				comp.state = {};
				var data = this.getManagerData(comp);

				data.props_ = new _state2.default(comp.getInitialConfig(), comp.props, comp);
				data.props_.configState(_metal.object.mixin({}, config, (0, _metal.getStaticProperty)(ctor, 'PROPS', _state2.default.mergeState)));
				this.addUnconfiguredProps_(comp, data.props_, comp.getInitialConfig());

				data.state_ = new _state2.default({}, comp.state, comp);
				data.state_.setEventData({
					type: 'state'
				});
				data.state_.configState(_state2.default.getStateStatic(ctor));
			}
		}, {
			key: 'dispose',
			value: function dispose(component) {
				var data = this.getManagerData(component);
				data.props_.dispose();
				_component.ComponentDataManager.dispose.call(this, component);
			}
		}, {
			key: 'get',
			value: function get(component, name) {
				return this.getManagerData(component).props_.get(name);
			}
		}, {
			key: 'getPropsInstance',
			value: function getPropsInstance(component) {
				return this.getManagerData(component).props_;
			}
		}, {
			key: 'getSyncKeys',
			value: function getSyncKeys(component) {
				return this.getManagerData(component).props_.getStateKeys();
			}
		}, {
			key: 'replaceNonInternal',
			value: function replaceNonInternal(component, data) {
				var prevProps = void 0;
				if (component.propsChanged) {
					prevProps = _metal.object.mixin({}, component.props);
				}

				var props = this.getManagerData(component).props_;
				_component.ComponentDataManager.replaceNonInternal.call(this, component, data, props); // eslint-disable-line
				this.addUnconfiguredProps_(component, props, data);
				if (component.propsChanged) {
					component.propsChanged(prevProps);
				}
			}
		}]);

		return JSXDataManager;
	}(_component.ComponentDataManager.constructor);

	exports.default = new JSXDataManager();
});
//# sourceMappingURL=JSXDataManager.js.map
